import 'package:w_transport/w_transport.dart' as w_transport;
import 'package:w_transport/vm.dart' show vmTransportPlatform;

import 'dart:async';

class HttpWrapper {
  String _clientId;
  String _clientSecret;

  final String _baseUrl = "https://api.imgur.com";
  final String _version = "/3";

  HttpWrapper(this._clientId, this._clientSecret) {
    w_transport.globalTransportPlatform = vmTransportPlatform;
  }

  Future<ResponseWrapper> createRequest(String method, String path,
      {Map<String, dynamic> body,
      Map<String, String> params,
      bool auth: false}) async {
    var req = new w_transport.JsonRequest()
      ..uri = Uri.parse(_baseUrl + _version + path)
      ..body = body
      ..queryParameters = params;

    if (!auth)
      req.headers = {"Authorization": "Client-ID $_clientId"};
    else
      req.headers = {"Authorization": "Bearer $_clientSecret"};

    var res = await req.send(method);
    return new ResponseWrapper(
        res.body.asJson() as Map<String, dynamic>, res.status);
  }
}

class ResponseWrapper {
  Map<String, dynamic> response;
  int code;

  ResponseWrapper(this.response, this.code);
}
